/**
  @file wapi.h

  Copyright (C) 2009 Nokia Corporation. All rights reserved.

  @author Usman Rahim <usman.rahim@nokia.com>

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef _WAPI_H_
#define _WAPI_H_

#include <asm/types.h>
#include "common.h"

#define WAPI_ELEMENT 0x44
#define WAPI_VERSION 1

struct wapi_ie_t {
	guint8 element_id;
	guint8 length;
	guint16 version;
} __attribute__ ((packed));

/* wapi cipher suites */
static const guint8 CIPHER_SUITE_WAPI[] = {0x00, 0x14, 0x72, 1};

/* wapi authentication and key management suites */
static const guint8 WAPI_KEY_MGMT_CERT[] = {0x00, 0x14, 0x72, 1};
static const guint8 WAPI_KEY_MGMT_PSK[]  = {0x00, 0x14, 0x72, 2};

int parse_wapi_ie(unsigned char* wapi_ie, unsigned int wapi_ie_len, struct ap_info_t* ap_info);
int generate_wapi_ie(guint32 encryption, struct wlan_status_t *wlan_status);

#endif /* _WAPI_H_ */
